diff --git a/gfx/harfbuzz/src/check-header-guards.py b/gfx/harfbuzz/src/check-header-guards.py
index ba7d42fbac..a3de9c5184 100644
--- a/gfx/harfbuzz/src/check-header-guards.py
+++ b/gfx/harfbuzz/src/check-header-guards.py
@@ -1,34 +1,35 @@
-#!/usr/bin/env python3
-
-import sys, os, re
-
-srcdir = os.getenv ('srcdir', os.path.dirname (__file__))
-base_srcdir = os.getenv ('base_srcdir', srcdir)
-
-os.chdir (srcdir)
-
-def removeprefix(s):
-	abs_path = os.path.join(base_srcdir, s)
-	return os.path.relpath(abs_path, srcdir)
-
-
-HBHEADERS = [os.path.basename (x) for x in os.getenv ('HBHEADERS', '').split ()] or \
-	[x for x in os.listdir ('.') if x.startswith ('hb') and x.endswith ('.h')]
-HBSOURCES = [
-    removeprefix(x) for x in os.getenv ('HBSOURCES', '').split ()
-] or [
-    x for x in os.listdir ('.') if x.startswith ('hb') and x.endswith (('.cc', '.hh'))
-]
-
-
-stat = 0
-
-for x in HBHEADERS + HBSOURCES:
-	if not x.endswith ('h') or x == 'hb-gobject-structs.h': continue
-	tag = x.upper ().replace ('.', '_').replace ('-', '_').replace(os.path.sep, '_').replace('/', '_')
-	with open (x, 'r', encoding='utf-8') as f: content = f.read ()
-	if len (re.findall (tag + r'\b', content)) != 3:
-		print ('Ouch, header file %s does not have correct preprocessor guards. Expected: %s' % (x, tag))
-		stat = 1
-
-sys.exit (stat)
+#!/usr/bin/env python3
+
+from __future__ import print_function
+import sys, os, re
+
+srcdir = os.getenv ('srcdir', os.path.dirname (__file__))
+base_srcdir = os.getenv ('base_srcdir', srcdir)
+
+os.chdir (srcdir)
+
+def removeprefix(s):
+	abs_path = os.path.join(base_srcdir, s)
+	return os.path.relpath(abs_path, srcdir)
+
+
+HBHEADERS = [os.path.basename (x) for x in os.getenv ('HBHEADERS', '').split ()] or \
+	[x for x in os.listdir ('.') if x.startswith ('hb') and x.endswith ('.h')]
+HBSOURCES = [
+    removeprefix(x) for x in os.getenv ('HBSOURCES', '').split ()
+] or [
+    x for x in os.listdir ('.') if x.startswith ('hb') and x.endswith (('.cc', '.hh'))
+]
+
+
+stat = 0
+
+for x in HBHEADERS + HBSOURCES:
+	if not x.endswith ('h') or x == 'hb-gobject-structs.h': continue
+	tag = x.upper ().replace ('.', '_').replace ('-', '_').replace(os.path.sep, '_').replace('/', '_')
+	with open (x, 'r', encoding='utf-8') as f: content = f.read ()
+	if len (re.findall (tag + r'\b', content)) != 3:
+		print(('Ouch, header file %s does not have correct preprocessor guards. Expected: %s' % (x, tag)))
+		stat = 1
+
+sys.exit (stat)
diff --git a/gfx/harfbuzz/src/check-includes.py b/gfx/harfbuzz/src/check-includes.py
index 2cead7b3f9..829ac835eb 100644
--- a/gfx/harfbuzz/src/check-includes.py
+++ b/gfx/harfbuzz/src/check-includes.py
@@ -1,51 +1,52 @@
-#!/usr/bin/env python3
-
-import sys, os, re
-
-srcdir = os.getenv ('srcdir', os.path.dirname (__file__))
-base_srcdir = os.getenv ('base_srcdir', srcdir)
-
-os.chdir (srcdir)
-
-def removeprefix(s):
-	abs_path = os.path.join(base_srcdir, s)
-	return os.path.relpath(abs_path, srcdir)
-
-HBHEADERS = [os.path.basename (x) for x in os.getenv ('HBHEADERS', '').split ()] or \
-	[x for x in os.listdir ('.') if x.startswith ('hb') and x.endswith ('.h')]
-
-HBSOURCES = [
-    removeprefix(x) for x in os.getenv ('HBSOURCES', '').split ()
-] or [
-    x for x in os.listdir ('.') if x.startswith ('hb') and x.endswith (('.cc', '.hh'))
-]
-
-
-stat = 0
-
-print ('Checking that public header files #include "hb-common.h" or "hb.h" first (or none)')
-for x in HBHEADERS:
-	if x == 'hb.h' or x == 'hb-common.h': continue
-	with open (x, 'r', encoding='utf-8') as f: content = f.read ()
-	first = re.findall (r'#.*include.*', content)[0]
-	if first not in ['#include "hb.h"', '#include "hb-common.h"']:
-		print ('failure on %s' % x)
-		stat = 1
-
-print ('Checking that source files #include a private header first (or none)')
-for x in HBSOURCES:
-	with open (x, 'r', encoding='utf-8') as f: content = f.read ()
-	includes = re.findall (r'#.*include.*', content)
-	if includes:
-		if not len (re.findall (r'".*\.hh"', includes[0])):
-			print ('failure on %s' % x)
-			stat = 1
-
-print ('Checking that there is no #include <hb-*.h>')
-for x in HBHEADERS + HBSOURCES:
-	with open (x, 'r', encoding='utf-8') as f: content = f.read ()
-	if re.findall ('#.*include.*<.*hb', content):
-		print ('failure on %s' % x)
-		stat = 1
-
-sys.exit (stat)
+#!/usr/bin/env python3
+
+from __future__ import print_function
+import sys, os, re
+
+srcdir = os.getenv ('srcdir', os.path.dirname (__file__))
+base_srcdir = os.getenv ('base_srcdir', srcdir)
+
+os.chdir (srcdir)
+
+def removeprefix(s):
+	abs_path = os.path.join(base_srcdir, s)
+	return os.path.relpath(abs_path, srcdir)
+
+HBHEADERS = [os.path.basename (x) for x in os.getenv ('HBHEADERS', '').split ()] or \
+	[x for x in os.listdir ('.') if x.startswith ('hb') and x.endswith ('.h')]
+
+HBSOURCES = [
+    removeprefix(x) for x in os.getenv ('HBSOURCES', '').split ()
+] or [
+    x for x in os.listdir ('.') if x.startswith ('hb') and x.endswith (('.cc', '.hh'))
+]
+
+
+stat = 0
+
+print ('Checking that public header files #include "hb-common.h" or "hb.h" first (or none)')
+for x in HBHEADERS:
+	if x == 'hb.h' or x == 'hb-common.h': continue
+	with open (x, 'r', encoding='utf-8') as f: content = f.read ()
+	first = re.findall (r'#.*include.*', content)[0]
+	if first not in ['#include "hb.h"', '#include "hb-common.h"']:
+		print(('failure on %s' % x))
+		stat = 1
+
+print ('Checking that source files #include a private header first (or none)')
+for x in HBSOURCES:
+	with open (x, 'r', encoding='utf-8') as f: content = f.read ()
+	includes = re.findall (r'#.*include.*', content)
+	if includes:
+		if not len (re.findall (r'".*\.hh"', includes[0])):
+			print(('failure on %s' % x))
+			stat = 1
+
+print ('Checking that there is no #include <hb-*.h>')
+for x in HBHEADERS + HBSOURCES:
+	with open (x, 'r', encoding='utf-8') as f: content = f.read ()
+	if re.findall ('#.*include.*<.*hb', content):
+		print(('failure on %s' % x))
+		stat = 1
+
+sys.exit (stat)
diff --git a/gfx/harfbuzz/src/check-libstdc++.py b/gfx/harfbuzz/src/check-libstdc++.py
index 4cfab52d4b..ffa11d245e 100644
--- a/gfx/harfbuzz/src/check-libstdc++.py
+++ b/gfx/harfbuzz/src/check-libstdc++.py
@@ -1,39 +1,40 @@
-#!/usr/bin/env python3
-
-import sys, os, shutil, subprocess
-
-os.chdir (os.getenv ('srcdir', os.path.dirname (__file__)))
-
-libs = os.getenv ('libs', '.libs')
-
-ldd = os.getenv ('LDD', shutil.which ('ldd'))
-if not ldd:
-	otool = os.getenv ('OTOOL', shutil.which ('otool'))
-	if otool:
-		ldd = otool + ' -L'
-	else:
-		print ('check-libstdc++.py: \'ldd\' not found; skipping test')
-		sys.exit (77)
-
-stat = 0
-tested = False
-
-# harfbuzz-icu links to libstdc++ because icu does.
-for soname in ['harfbuzz', 'harfbuzz-subset', 'harfbuzz-gobject', 'harfbuzz-cairo']:
-	for suffix in ['so', 'dylib']:
-		so = os.path.join (libs, 'lib%s.%s' % (soname, suffix))
-		if not os.path.exists (so): continue
-
-		print ('Checking that we are not linking to libstdc++ or libc++ in %s' % so)
-		ldd_result = subprocess.check_output (ldd.split() + [so])
-		if (b'libstdc++' in ldd_result) or (b'libc++' in ldd_result):
-			print ('Ouch, %s is linked to libstdc++ or libc++' % so)
-			stat = 1
-
-		tested = True
-
-if not tested:
-	print ('check-libstdc++.py: libharfbuzz shared library not found; skipping test')
-	sys.exit (77)
-
-sys.exit (stat)
+#!/usr/bin/env python3
+
+from __future__ import print_function
+import sys, os, shutil, subprocess
+
+os.chdir (os.getenv ('srcdir', os.path.dirname (__file__)))
+
+libs = os.getenv ('libs', '.libs')
+
+ldd = os.getenv ('LDD', shutil.which ('ldd'))
+if not ldd:
+	otool = os.getenv ('OTOOL', shutil.which ('otool'))
+	if otool:
+		ldd = otool + ' -L'
+	else:
+		print ('check-libstdc++.py: \'ldd\' not found; skipping test')
+		sys.exit (77)
+
+stat = 0
+tested = False
+
+# harfbuzz-icu links to libstdc++ because icu does.
+for soname in ['harfbuzz', 'harfbuzz-subset', 'harfbuzz-gobject', 'harfbuzz-cairo']:
+	for suffix in ['so', 'dylib']:
+		so = os.path.join (libs, 'lib%s.%s' % (soname, suffix))
+		if not os.path.exists (so): continue
+
+		print(('Checking that we are not linking to libstdc++ or libc++ in %s' % so))
+		ldd_result = subprocess.check_output (ldd.split() + [so])
+		if (b'libstdc++' in ldd_result) or (b'libc++' in ldd_result):
+			print(('Ouch, %s is linked to libstdc++ or libc++' % so))
+			stat = 1
+
+		tested = True
+
+if not tested:
+	print ('check-libstdc++.py: libharfbuzz shared library not found; skipping test')
+	sys.exit (77)
+
+sys.exit (stat)
diff --git a/gfx/harfbuzz/src/check-static-inits.py b/gfx/harfbuzz/src/check-static-inits.py
index 7217f03934..4e5ab1bd86 100644
--- a/gfx/harfbuzz/src/check-static-inits.py
+++ b/gfx/harfbuzz/src/check-static-inits.py
@@ -1,51 +1,52 @@
-#!/usr/bin/env python3
-
-import sys, os, shutil, subprocess, glob, re
-
-builddir = os.getenv ('builddir', os.path.dirname (__file__))
-libs = os.getenv ('libs', '.libs')
-
-objdump = os.getenv ('OBJDUMP', shutil.which ('objdump'))
-if not objdump:
-	print ('check-static-inits.py: \'ldd\' not found; skipping test')
-	sys.exit (77)
-
-if sys.version_info < (3, 5):
-	print ('check-static-inits.py: needs python 3.5 for recursive support in glob')
-	sys.exit (77)
-
-OBJS = glob.glob (os.path.join (builddir, libs, '**', '*hb*.o'), recursive=True)
-if not OBJS:
-	print ('check-static-inits.py: object files not found; skipping test')
-	sys.exit (77)
-
-stat = 0
-tested = 0
-
-for obj in OBJS:
-	result = subprocess.run(objdump.split () + ['-t', obj], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
-
-	if result.returncode:
-		if result.stderr.find (b'not recognized') != -1:
-			# https://github.com/harfbuzz/harfbuzz/issues/3019
-			print ('objdump %s returned "not recognized", skipping' % obj)
-			continue
-		print ('objdump %s returned error:\n%s' % (obj, result.stderr.decode ('utf-8')))
-		stat = 2
-
-	result = result.stdout.decode ('utf-8')
-
-	# Checking that no object file has static initializers
-	for l in re.findall (r'^.*\.[cd]tors.*$', result, re.MULTILINE):
-		if not re.match (r'.*\b0+\b', l):
-			print ('Ouch, %s has static initializers/finalizers' % obj)
-			stat = 1
-
-	# Checking that no object file has lazy static C++ constructors/destructors or other such stuff
-	if ('__cxa_' in result) and ('__ubsan_handle' not in result):
-		print ('Ouch, %s has lazy static C++ constructors/destructors or other such stuff' % obj)
-		stat = 1
-
-	tested += 1
-
-sys.exit (stat if tested else 77)
+#!/usr/bin/env python3
+
+from __future__ import print_function
+import sys, os, shutil, subprocess, glob, re
+
+builddir = os.getenv ('builddir', os.path.dirname (__file__))
+libs = os.getenv ('libs', '.libs')
+
+objdump = os.getenv ('OBJDUMP', shutil.which ('objdump'))
+if not objdump:
+	print ('check-static-inits.py: \'ldd\' not found; skipping test')
+	sys.exit (77)
+
+if sys.version_info < (3, 5):
+	print ('check-static-inits.py: needs python 3.5 for recursive support in glob')
+	sys.exit (77)
+
+OBJS = glob.glob (os.path.join (builddir, libs, '**', '*hb*.o'), recursive=True)
+if not OBJS:
+	print ('check-static-inits.py: object files not found; skipping test')
+	sys.exit (77)
+
+stat = 0
+tested = 0
+
+for obj in OBJS:
+	result = subprocess.run(objdump.split () + ['-t', obj], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
+
+	if result.returncode:
+		if result.stderr.find (b'not recognized') != -1:
+			# https://github.com/harfbuzz/harfbuzz/issues/3019
+			print(('objdump %s returned "not recognized", skipping' % obj))
+			continue
+		print(('objdump %s returned error:\n%s' % (obj, result.stderr.decode ('utf-8'))))
+		stat = 2
+
+	result = result.stdout.decode ('utf-8')
+
+	# Checking that no object file has static initializers
+	for l in re.findall (r'^.*\.[cd]tors.*$', result, re.MULTILINE):
+		if not re.match (r'.*\b0+\b', l):
+			print(('Ouch, %s has static initializers/finalizers' % obj))
+			stat = 1
+
+	# Checking that no object file has lazy static C++ constructors/destructors or other such stuff
+	if ('__cxa_' in result) and ('__ubsan_handle' not in result):
+		print(('Ouch, %s has lazy static C++ constructors/destructors or other such stuff' % obj))
+		stat = 1
+
+	tested += 1
+
+sys.exit (stat if tested else 77)
diff --git a/gfx/harfbuzz/src/check-symbols.py b/gfx/harfbuzz/src/check-symbols.py
index 2a9d58592a..0424584cea 100644
--- a/gfx/harfbuzz/src/check-symbols.py
+++ b/gfx/harfbuzz/src/check-symbols.py
@@ -1,74 +1,75 @@
-#!/usr/bin/env python3
-
-import sys, os, shutil, subprocess, re, difflib
-
-os.environ['LC_ALL'] = 'C' # otherwise 'nm' prints in wrong order
-
-builddir = os.getenv ('builddir', os.path.dirname (__file__))
-libs = os.getenv ('libs', '.libs')
-
-IGNORED_SYMBOLS = '|'.join(['_fini', '_init', '_fdata', '_ftext', '_fbss',
-	'__bss_start', '__bss_start__', '__bss_end__', '_edata', '_end', '_bss_end__',
-	'__end__', '__gcov_.*', 'llvm_.*', 'flush_fn_list', 'writeout_fn_list', 'mangle_path',
-	'lprofDirMode', 'reset_fn_list'])
-
-nm = os.getenv ('NM', shutil.which ('nm'))
-if not nm:
-	print ('check-symbols.py: \'nm\' not found; skipping test')
-	sys.exit (77)
-
-cxxfilt = shutil.which ('c++filt')
-
-tested = False
-stat = 0
-
-for soname in ['harfbuzz', 'harfbuzz-subset', 'harfbuzz-icu', 'harfbuzz-gobject', 'harfbuzz-cairo']:
-	for suffix in ['so', 'dylib']:
-		so = os.path.join (builddir, libs, 'lib%s.%s' % (soname, suffix))
-		if not os.path.exists (so): continue
-
-		# On macOS, C symbols are prefixed with _
-		symprefix = '_' if suffix == 'dylib' else ''
-
-		EXPORTED_SYMBOLS = [s.split ()[2]
-				    for s in re.findall (r'^.+ [BCDGIRSTu] .+$', subprocess.check_output (nm.split() + [so]).decode ('utf-8'), re.MULTILINE)
-				    if not re.match (r'.* %s(%s)\b' % (symprefix, IGNORED_SYMBOLS), s)]
-
-		# run again c++filt also if is available
-		if cxxfilt:
-			EXPORTED_SYMBOLS = subprocess.check_output (
-				[cxxfilt], input='\n'.join (EXPORTED_SYMBOLS).encode ()
-			).decode ('utf-8').splitlines ()
-
-		prefix = (symprefix + os.path.basename (so)).replace ('libharfbuzz', 'hb').replace ('-', '_').split ('.')[0]
-
-		print ('Checking that %s does not expose internal symbols' % so)
-		suspicious_symbols = [x for x in EXPORTED_SYMBOLS if not re.match (r'^%s(_|$)' % prefix, x)]
-		if suspicious_symbols:
-			print ('Ouch, internal symbols exposed:', suspicious_symbols)
-			stat = 1
-
-		def_path = os.path.join (builddir, soname + '.def')
-		if not os.path.exists (def_path):
-			print ('\'%s\' not found; skipping' % def_path)
-		else:
-			print ('Checking that %s has the same symbol list as %s' % (so, def_path))
-			with open (def_path, 'r', encoding='utf-8') as f: def_file = f.read ()
-			diff_result = list (difflib.context_diff (
-				def_file.splitlines (),
-				['EXPORTS'] + [re.sub ('^%shb' % symprefix, 'hb', x) for x in EXPORTED_SYMBOLS] +
-					# cheat: copy the last line from the def file!
-					[def_file.splitlines ()[-1]]
-			))
-
-			if diff_result:
-				print ('\n'.join (diff_result))
-				stat = 1
-
-			tested = True
-
-if not tested:
-	print ('check-symbols.py: no shared libraries found; skipping test')
-	sys.exit (77)
-
-sys.exit (stat)
+#!/usr/bin/env python3
+
+from __future__ import print_function
+import sys, os, shutil, subprocess, re, difflib
+
+os.environ['LC_ALL'] = 'C' # otherwise 'nm' prints in wrong order
+
+builddir = os.getenv ('builddir', os.path.dirname (__file__))
+libs = os.getenv ('libs', '.libs')
+
+IGNORED_SYMBOLS = '|'.join(['_fini', '_init', '_fdata', '_ftext', '_fbss',
+	'__bss_start', '__bss_start__', '__bss_end__', '_edata', '_end', '_bss_end__',
+	'__end__', '__gcov_.*', 'llvm_.*', 'flush_fn_list', 'writeout_fn_list', 'mangle_path',
+	'lprofDirMode', 'reset_fn_list'])
+
+nm = os.getenv ('NM', shutil.which ('nm'))
+if not nm:
+	print ('check-symbols.py: \'nm\' not found; skipping test')
+	sys.exit (77)
+
+cxxfilt = shutil.which ('c++filt')
+
+tested = False
+stat = 0
+
+for soname in ['harfbuzz', 'harfbuzz-subset', 'harfbuzz-icu', 'harfbuzz-gobject', 'harfbuzz-cairo']:
+	for suffix in ['so', 'dylib']:
+		so = os.path.join (builddir, libs, 'lib%s.%s' % (soname, suffix))
+		if not os.path.exists (so): continue
+
+		# On macOS, C symbols are prefixed with _
+		symprefix = '_' if suffix == 'dylib' else ''
+
+		EXPORTED_SYMBOLS = [s.split ()[2]
+				    for s in re.findall (r'^.+ [BCDGIRSTu] .+$', subprocess.check_output (nm.split() + [so]).decode ('utf-8'), re.MULTILINE)
+				    if not re.match (r'.* %s(%s)\b' % (symprefix, IGNORED_SYMBOLS), s)]
+
+		# run again c++filt also if is available
+		if cxxfilt:
+			EXPORTED_SYMBOLS = subprocess.check_output (
+				[cxxfilt], input='\n'.join (EXPORTED_SYMBOLS).encode ()
+			).decode ('utf-8').splitlines ()
+
+		prefix = (symprefix + os.path.basename (so)).replace ('libharfbuzz', 'hb').replace ('-', '_').split ('.')[0]
+
+		print(('Checking that %s does not expose internal symbols' % so))
+		suspicious_symbols = [x for x in EXPORTED_SYMBOLS if not re.match (r'^%s(_|$)' % prefix, x)]
+		if suspicious_symbols:
+			print(('Ouch, internal symbols exposed:', suspicious_symbols))
+			stat = 1
+
+		def_path = os.path.join (builddir, soname + '.def')
+		if not os.path.exists (def_path):
+			print(('\'%s\' not found; skipping' % def_path))
+		else:
+			print(('Checking that %s has the same symbol list as %s' % (so, def_path)))
+			with open (def_path, 'r', encoding='utf-8') as f: def_file = f.read ()
+			diff_result = list (difflib.context_diff (
+				def_file.splitlines (),
+				['EXPORTS'] + [re.sub ('^%shb' % symprefix, 'hb', x) for x in EXPORTED_SYMBOLS] +
+					# cheat: copy the last line from the def file!
+					[def_file.splitlines ()[-1]]
+			))
+
+			if diff_result:
+				print(('\n'.join (diff_result)))
+				stat = 1
+
+			tested = True
+
+if not tested:
+	print ('check-symbols.py: no shared libraries found; skipping test')
+	sys.exit (77)
+
+sys.exit (stat)
diff --git a/gfx/harfbuzz/src/gen-arabic-joining-list.py b/gfx/harfbuzz/src/gen-arabic-joining-list.py
index 6894b84ed9..e40be70cdc 100644
--- a/gfx/harfbuzz/src/gen-arabic-joining-list.py
+++ b/gfx/harfbuzz/src/gen-arabic-joining-list.py
@@ -1,106 +1,107 @@
-#!/usr/bin/env python3
-
-"""usage: ./gen-arabic-joining-table.py ArabicShaping.txt Scripts.txt
-
-Input files:
-* https://unicode.org/Public/UCD/latest/ucd/ArabicShaping.txt
-* https://unicode.org/Public/UCD/latest/ucd/Scripts.txt
-"""
-
-import os.path, sys
-
-if len (sys.argv) != 3:
-	sys.exit (__doc__)
-
-files = [open (x, encoding='utf-8') for x in sys.argv[1:]]
-
-headers = [[f.readline (), f.readline ()] for f in files]
-while files[0].readline ().find ('##################') < 0:
-	pass
-
-def read (f):
-	mapping = {}
-	for line in f:
-
-		j = line.find ('#')
-		if j >= 0:
-			line = line[:j]
-
-		fields = [x.strip () for x in line.split (';')]
-		if len (fields) == 1:
-			continue
-
-		uu = fields[0].split ('..')
-		start = int (uu[0], 16)
-		if len (uu) == 1:
-			end = start
-		else:
-			end = int (uu[1], 16)
-
-		t = fields[1]
-
-		for u in range (start, end + 1):
-			mapping[u] = t
-
-	return mapping
-
-def read_joining_uu (f):
-	values = set ()
-	for line in f:
-
-		if line[0] == '#':
-			continue
-
-		fields = [x.strip () for x in line.split (';')]
-		if len (fields) == 1:
-			continue
-		if fields[2] in {'T', 'U'}:
-			continue
-
-		values.add (int (fields[0], 16))
-
-	return sorted (values)
-
-def print_has_arabic_joining (scripts, joining_uu):
-
-	print ("static bool")
-	print ("has_arabic_joining (hb_script_t script)")
-	print ("{")
-	print ("  /* List of scripts that have data in arabic-table. */")
-	print ("  switch ((int) script)")
-	print ("  {")
-
-	for script in sorted ({scripts[u] for u in joining_uu if scripts[u] not in {'Common', 'Inherited'}}):
-		print ("    case HB_SCRIPT_{}:".format (script.upper ()))
-
-	print ("      return true;")
-	print ()
-	print ("    default:")
-	print ("      return false;")
-	print ("  }")
-	print ("}")
-	print ()
-
-print ("/* == Start of generated function == */")
-print ("/*")
-print (" * The following function is generated by running:")
-print (" *")
-print (" *   ./gen-arabic-joining-list.py ArabicShaping.txt Scripts.txt")
-print (" *")
-print (" * on files with these headers:")
-print (" *")
-for h in headers:
-	for l in h:
-		print (" * %s" % (l.strip ()))
-print (" */")
-print ()
-print ("#ifndef HB_OT_SHAPER_ARABIC_JOINING_LIST_HH")
-print ("#define HB_OT_SHAPER_ARABIC_JOINING_LIST_HH")
-print ()
-
-print_has_arabic_joining (read (files[1]), read_joining_uu (files[0]))
-
-print ()
-print ("#endif /* HB_OT_SHAPER_ARABIC_JOINING_LIST_HH */")
-print ()
-print ("/* == End of generated function == */")
+#!/usr/bin/env python3
+
+"""usage: ./gen-arabic-joining-table.py ArabicShaping.txt Scripts.txt
+
+Input files:
+* https://unicode.org/Public/UCD/latest/ucd/ArabicShaping.txt
+* https://unicode.org/Public/UCD/latest/ucd/Scripts.txt
+"""
+
+from __future__ import print_function
+import os.path, sys
+
+if len (sys.argv) != 3:
+	sys.exit (__doc__)
+
+files = [open (x, encoding='utf-8') for x in sys.argv[1:]]
+
+headers = [[f.readline (), f.readline ()] for f in files]
+while files[0].readline ().find ('##################') < 0:
+	pass
+
+def read (f):
+	mapping = {}
+	for line in f:
+
+		j = line.find ('#')
+		if j >= 0:
+			line = line[:j]
+
+		fields = [x.strip () for x in line.split (';')]
+		if len (fields) == 1:
+			continue
+
+		uu = fields[0].split ('..')
+		start = int (uu[0], 16)
+		if len (uu) == 1:
+			end = start
+		else:
+			end = int (uu[1], 16)
+
+		t = fields[1]
+
+		for u in range (start, end + 1):
+			mapping[u] = t
+
+	return mapping
+
+def read_joining_uu (f):
+	values = set ()
+	for line in f:
+
+		if line[0] == '#':
+			continue
+
+		fields = [x.strip () for x in line.split (';')]
+		if len (fields) == 1:
+			continue
+		if fields[2] in {'T', 'U'}:
+			continue
+
+		values.add (int (fields[0], 16))
+
+	return sorted (values)
+
+def print_has_arabic_joining (scripts, joining_uu):
+
+	print ("static bool")
+	print ("has_arabic_joining (hb_script_t script)")
+	print ("{")
+	print ("  /* List of scripts that have data in arabic-table. */")
+	print ("  switch ((int) script)")
+	print ("  {")
+
+	for script in sorted ({scripts[u] for u in joining_uu if scripts[u] not in {'Common', 'Inherited'}}):
+		print(("    case HB_SCRIPT_{}:".format (script.upper ())))
+
+	print ("      return true;")
+	print ()
+	print ("    default:")
+	print ("      return false;")
+	print ("  }")
+	print ("}")
+	print ()
+
+print ("/* == Start of generated function == */")
+print ("/*")
+print (" * The following function is generated by running:")
+print (" *")
+print (" *   ./gen-arabic-joining-list.py ArabicShaping.txt Scripts.txt")
+print (" *")
+print (" * on files with these headers:")
+print (" *")
+for h in headers:
+	for l in h:
+		print((" * %s" % (l.strip ())))
+print (" */")
+print ()
+print ("#ifndef HB_OT_SHAPER_ARABIC_JOINING_LIST_HH")
+print ("#define HB_OT_SHAPER_ARABIC_JOINING_LIST_HH")
+print ()
+
+print_has_arabic_joining (read (files[1]), read_joining_uu (files[0]))
+
+print ()
+print ("#endif /* HB_OT_SHAPER_ARABIC_JOINING_LIST_HH */")
+print ()
+print ("/* == End of generated function == */")
diff --git a/gfx/harfbuzz/src/gen-os2-unicode-ranges.py b/gfx/harfbuzz/src/gen-os2-unicode-ranges.py
index b8b6489dfc..d7e5f27203 100644
--- a/gfx/harfbuzz/src/gen-os2-unicode-ranges.py
+++ b/gfx/harfbuzz/src/gen-os2-unicode-ranges.py
@@ -1,50 +1,51 @@
-#!/usr/bin/env python3
-
-"""Generates the code for a sorted unicode range array as used in hb-ot-os2-unicode-ranges.hh
-Input is a tab separated list of unicode ranges from the otspec
-(https://docs.microsoft.com/en-us/typography/opentype/spec/os2#ur).
-"""
-
-import re
-import sys
-
-
-print ("""static OS2Range _hb_os2_unicode_ranges[] =
-{""")
-
-args = sys.argv[1:]
-input_file = args[0]
-
-with open (input_file, mode="r", encoding="utf-8") as f:
-
-  all_ranges = []
-  current_bit = 0
-  while True:
-    line = f.readline().strip()
-    if not line:
-      break
-    fields = re.split(r'\t+', line)
-    if len(fields) == 3:
-      current_bit = fields[0]
-      fields = fields[1:]
-    elif len(fields) > 3:
-      raise Exception("bad input :(.")
-
-    name = fields[0]
-    ranges = re.split("-", fields[1])
-    if len(ranges) != 2:
-      raise Exception("bad input :(.")
-
-    v = tuple((int(ranges[0], 16), int(ranges[1], 16), int(current_bit), name))
-    all_ranges.append(v)
-
-all_ranges = sorted(all_ranges, key=lambda t: t[0])
-
-for ranges in all_ranges:
-  start = ("0x%X" % ranges[0]).rjust(8)
-  end = ("0x%X" % ranges[1]).rjust(8)
-  bit = ("%s" % ranges[2]).rjust(3)
-
-  print ("  {%s, %s, %s}, // %s" % (start, end, bit, ranges[3]))
-
-print ("""};""")
+#!/usr/bin/env python3
+
+"""Generates the code for a sorted unicode range array as used in hb-ot-os2-unicode-ranges.hh
+Input is a tab separated list of unicode ranges from the otspec
+(https://docs.microsoft.com/en-us/typography/opentype/spec/os2#ur).
+"""
+
+from __future__ import print_function
+import re
+import sys
+
+
+print ("""static OS2Range _hb_os2_unicode_ranges[] =
+{""")
+
+args = sys.argv[1:]
+input_file = args[0]
+
+with open (input_file, mode="r", encoding="utf-8") as f:
+
+  all_ranges = []
+  current_bit = 0
+  while True:
+    line = f.readline().strip()
+    if not line:
+      break
+    fields = re.split(r'\t+', line)
+    if len(fields) == 3:
+      current_bit = fields[0]
+      fields = fields[1:]
+    elif len(fields) > 3:
+      raise Exception("bad input :(.")
+
+    name = fields[0]
+    ranges = re.split("-", fields[1])
+    if len(ranges) != 2:
+      raise Exception("bad input :(.")
+
+    v = tuple((int(ranges[0], 16), int(ranges[1], 16), int(current_bit), name))
+    all_ranges.append(v)
+
+all_ranges = sorted(all_ranges, key=lambda t: t[0])
+
+for ranges in all_ranges:
+  start = ("0x%X" % ranges[0]).rjust(8)
+  end = ("0x%X" % ranges[1]).rjust(8)
+  bit = ("%s" % ranges[2]).rjust(3)
+
+  print(("  {%s, %s, %s}, // %s" % (start, end, bit, ranges[3])))
+
+print ("""};""")
